<template>
    <div class="fillingDegree">
        <div class="item">
            <canvas  class="fillDegree" canvas-id="fillDegree" id="fillDegree" @tap.stop="tap"  @click.stop="handleChange('')"/>
<!--            <image v-if="fillDegreePath" class="fillDegree" :src="fillDegreePath"></image>-->
        </div>
    </div>
</template>

<script>
import uCharts from '@/components/u-charts.js';
var uChartsInstance = {};
export default {
    name: "fillingDegree",
    data() {
        return {
          width:0,
          fillDegreePath:'',
          selectIndex: 0,
          dataList : [],
          isTap:false,//判断是否走了tap
        }
    },
    props: {
        data: {
            type: Object,
            default: () => {}
        }
    },
    watch: {
        data: {
            handler(value) {
                this.handleCarData(value)
            },
            immediate: true
        }
    },
    methods: {
        handleChange(){
            if (this.isTap){
                this.isTap = false
            }else{
                this.$emit('handleChangeBandLevel',false)
            }
        },
        tap(e){
            uChartsInstance[e.target.id].showToolTip(e,{
                formatter: (item, category, index, opts) =>{
                    this.selectIndex = opts.series[index].key
                    if (this.selectIndex){
                        this.$emit('handleChangeBandLevel',this.selectIndex)
                    }else{
                        this.$emit('handleChangeBandLevel',false)
                    }
                    this.isTap = true
                    return item.name;
                }
            });
            uChartsInstance[e.target.id].touchLegend(e);
        },
        // 处理传入的数据
        handleCarData(value) {
            let res = value.result
            let config = {
                Abundant:value.Abundant
            }
            this.drawCharts('fillDegree', res ,config)
        },
        drawCharts(id, data,config) {
            const ctx = uni.createCanvasContext(id, this);
            let _this = this
            let phoneInfo = uni.getStorageSync('phoneInfo')
            this.width =  phoneInfo.screenWidth - 32
            uChartsInstance[id] = new uCharts({
                type: "ring",
                context: ctx,
                width: _this.width,
                height: 289,
                series: data.series,
                animation: false,
                rotate: false,
                rotateLock: false,
                background: "#FFFFFF",
                color: ["#1E80FF", "#00C2FF","#6B6FFF","#38C275","#F3BC1B","#ED6B5A","#FF9845","#74839D","#ACB9CD","#CAD0DA"],
                padding: [5, 5, 5, 5],
                dataLabel: false,
                enableScroll: false,
                title: {
                    name:config.Abundant?'盈足':'不盈足',
                    fontSize: 16,
                    color: "#341D00"
                },
                legend: {
                    show: true,
                    position: "right",
                    lineHeight: 25,
                    float: 'center'

                },
                extra: {
                    ring: {
                        ringWidth: 20,
                        activeOpacity: 0.5,
                        activeRadius: 10,
                        offsetAngle: -45,
                        labelWidth: 15,
                        border: false,
                        borderWidth: 3,
                        borderColor: "#FFFFFF"
                    }
                }
            });
          setTimeout( ()=>{
            // this.canvasToTempImage('fillDegree')
          },2000)
        },
      canvasToTempImage(id){
        uni.canvasToTempFilePath({
          canvasId:id,
          complete:(res)=>{
            if (res.tempFilePath){
              uni.getFileSystemManager().readFile({
                filePath: res.tempFilePath,
                encoding: 'base64',
                success: res => {
                  let base64 = 'data:image/png;base64,' + res.data;
                  this.fillDegreePath = base64
                }
              })
            }
          }
        },this)
      },
    }
}
</script>

<style scoped lang="scss">
.fillingDegree{
    width: 100%;
    margin-top: 12px;
    .item{
        width: 100%;
        height: 280px;
        .fillDegree{
            width: 100%;
            height: 100%;
        }
    }
}
</style>
